clear all; close all; fclose all; warning('off');

prompt = {'CAMPAGNE ( ECOAO or AWA)','CHOICE OF FREQUENCY TO ANALYZE (ECOAO--> 38, 70, 120 ou 200 kHz - AWA--> 18, 38, 70, 120, 200 ou 333 kHz)'};
dlg_title = 'Comparison of CTD and Echogram Profiles'; num_lines = 1; def={'ECOAO','38'}; answer = inputdlg(prompt,dlg_title,num_lines,def,'on');
if(strcmp(char(answer(1)),'ECOAO'))
    camp=1;
else
    camp=2;
end
FREQUENCES=str2num(char(answer(2)));
%==========================================================================

% directory address where the acoustic data is located
adress_acou_ECOAO='C:\Users\USER\Desktop\NEW_ARTICLE\CEprofil\ECOAO2013\Cruise_ECOAO2013\Treatment20171026_221343_75DB\CleanResults\Echointegration\';

% directory address where the profile files are located
adress_profil='C:\Users\USER\Desktop\NEW_ARTICLE\CEprofil\Station_ECOAO-AWA\';

% address of the file where the thicknesses are stored (exit of the "Layer.m" program)
adress_Ep='C:\Users\USER\Desktop\NEW_ARTICLE\CEprofil\ComparEchoProfil_couche\RESULTATS\';


NbESUVisu=2;  % number of esu to be visualized around the station

if(camp==1)
    TrialName='ECOAO';
    ProfilType=[2,10,14,20];
    FileNameProfil='CTD_stations_ECOAO';  
    adress_acou=adress_acou_ECOAO;
else
    TrialName='AWA';
    ProfilType=[3,9,12,16];
    FileNameProfil='CTD_stations_AWA';  
    adress_acou=adress_acou_AWA;
end
TypeEi='v';                                                      % ='v' to analyze the echogram of Sv, ='a' echogram of Sa
ProfName={'Temperature','Fluorescence','Oxygen','Density'};
ProfUnit= {'C','g/l','ml/l','kg/m^3'};
ProfilUpDown='d';                                                % ='d' to analyze the descending profile ou ='u' for the rising profile

% Saving figures
SaveFIG=1;        
SaveFIGppt=1;    
LabelFigHH=1;    


%**************************************************************************
% starting
%**************************************************************************
temp=pwd; 
if(~exist([temp,'\RESULTATS\'],'dir'))
    mkdir(temp,'RESULTATS');
end
pathSaveFig=[temp,'\','RESULTATS\']; clear temp;

%  profils loading
load('EK500_colourmap.dat'); ek5=EK500_colourmap; clear EK500_colourmap;
load([adress_profil,FileNameProfil,'.mat']); month=char(monthtr);

% layer.m loading
%load(adress_EpSvSa);

 load('EpSvSa.mat')

%for k=12:12
for k=1:length(hourtr)
    if(month(k,1)=='F')
        m=2;
    else
        m=3;
    end
    hh=str2num(hourtr(k,1:2)); mn=str2num(hourtr(k,4:5)); ss=str2num(hourtr(k,7:8));
    timep(k)=datenum([str2num(char(yeartr(k))),m,daytr(k),hh,mn,ss]); clear hh mn ss;
    timep70(k)=(timep(k)-datenum('1970-01-01 00:00'))*60*60*24; 
    timpstr(k,:)=datestr(datenum([1970 1 1 00 00 timep70(k)]),'yyyy-mm-dd HH:MM:SS');
    if(camp==1)
        temp=char(lattr(k)); ii=strfind(temp,''); dd=str2num(temp(1:ii-1)); mn=str2num(temp(ii+1:end-1)); lat(k)=dd + mn/60;
        if(temp(end)=='S')
            lat(k)=-lat(k);
        end
        clear temp ii dd mn;
        temp=char(lontr(k)); ii=strfind(temp,''); dd=str2num(temp(1:ii-1)); mn=str2num(temp(ii+1:end-1)); lon(k)=dd + mn/60;
        if(temp(end)=='W')
            lon(k)=-lon(k);
        end
        clear temp ii dd mn;
    else
        lat=lattr; lon=lontr;
    end
end
DateStation=timpstr;

filemat='Echointegration.mat';
str_fr0='000'; str_fr0(end-length(num2str(FREQUENCES))+1:end)=num2str(FREQUENCES);
repsave=[str_fr0,'kHz_',TrialName,'_',datestr(clock,'dd-mm-yyyy_HH-MM-SS')]; mkdir([pathSaveFig,repsave]);
save([pathSaveFig,repsave,'\ParametresDeTraitement.mat'],'DateStation','TrialName','adress_acou','adress_profil','TypeEi','FREQUENCES','FileNameProfil','ProfilType','ProfilUpDown','ProfName');

Kstation=0; Station=[]; kfile=1; load([adress_acou,filemat(kfile,:)],'Time'); nbesutot=size(Time,2); crit=0;
NbEsuBloc=1000; IdP=[1:NbEsuBloc];
while(crit==0)
    if(IdP(end)>=nbesutot)
        IdP=[IdP(1):nbesutot]; 
        crit=1;
    end
    
    load([adress_acou,filemat(kfile,:)],'Sv_surface','Sa_surface','Time','depth_surface','depth_bottom','TransducerDepth','Night1Sunrise2Day3Sunset4','FrequencySort','BottomShift'); 
    load([adress_acou,'Layer-65.mat'],'CleanLayMask');
    
    fprintf('OK\n');
    Sv_surface=Sv_surface(:,IdP,:); Sa_surface=Sa_surface(:,IdP,:); Time=Time(1,IdP); depth_bottom=depth_bottom(1,IdP);
    day_night_twilight=Night1Sunrise2Day3Sunset4(1,IdP);
    
    % mettre la ligne ci-dessous en commentaire (%) pour mettre tout l'chograme
    CleanLayMask=CleanLayMask(:,IdP,:); tmp=find(CleanLayMask~=0); CleanLayMask(tmp)=1; clear tmp; tmp=find(CleanLayMask==0); CleanLayMask(tmp)=NaN; clear tmp; Sv_surface=Sv_surface.*CleanLayMask; Sa_surface=Sa_surface.*CleanLayMask;
    
    transFreq=FrequencySort;
    ind=find(timep70>=Time(1) & timep70<=Time(end));
    if(~isempty(ind))
        
        for kp=1:length(ind)
            
            Kstation=Kstation+1;  % compteur de stations
            
            tmp=find(Time>=timep70(ind(kp))); IndStation=tmp(1); 
            if(day_night_twilight(IndStation)==1)
                JourNuitStation(Kstation,:)='Nuit  ';
            elseif(day_night_twilight(IndStation)==2)
                JourNuitStation(Kstation,:)='Lev  ';
            elseif(day_night_twilight(IndStation)==3)
                JourNuitStation(Kstation,:)='Jour  ';
            elseif(day_night_twilight(IndStation)==4)
                JourNuitStation(Kstation,:)='Couch';
            end
            
            tempek=[IndStation-NbESUVisu:1:IndStation+NbESUVisu]; clear tmp;
            if(tempek(1)<1)
                tempek=1:1:2*NbESUVisu;
            end
            if(tempek(end)>length(Time))
                tempek=length(Time)-2*NbESUVisu:1:length(Time);
            end
             
            dtim=Time(tempek);
            for k=1:length(Time)
                timtot(k,:)=datestr(datenum([1970 1 1 00 00 Time(k)]),'yyyy-mm-dd HH:MM:SS');
            end
            tim=timtot(tempek,:); DateESU=timtot;
            pingdeb=find(dtim>=timep70(ind(kp))); 
            if(isempty(pingdeb))
                pingdeb=find(abs(dtim-timep70(ind(kp)))==min(abs(dtim-timep70(ind(kp)))));
            end
            pingdeb=pingdeb(1);
            pingdebtot=find(Time>=timep70(ind(kp))); pingdebtot=pingdebtot(1);
            
            if(ProfilUpDown(1)=='d')
                Name=['profil_d_',num2str(ind(kp))]; proftot=eval(Name); clear Name; Name=['profildepth_d_',num2str(ind(kp))]; D=eval(Name); clear Name;
            else
                Name=['profil_u_',num2str(ind(kp))]; proftot=eval(Name); clear Name; Name=['profildepth_u_',num2str(ind(kp))]; D=eval(Name); clear Name;
            end
            prof=proftot(:,ProfilType);
            
            for Kfreq=1:length(FREQUENCES)
                
                kfreq=find(transFreq==FREQUENCES(Kfreq)*1000);

                Sv=Sv_surface(:,tempek,kfreq); Svtot=Sv_surface(:,:,kfreq); Sa=Sa_surface(:,tempek,kfreq);
                
                % suppression des NaNs
                Ks=1;
                for ks=1:size(Svtot,2)
                    tmp=find(~isnan(Svtot(:,ks)));
                    if(~isempty(tmp))
                        maxind(Ks)=tmp(end)+1; Ks=Ks+1;
                    end
                    clear tmp;
                end
                clear Ks; maxind=max(maxind); if(maxind>size(Svtot,1)); maxind=size(Svtot,1); end; Svtot=Svtot(1:maxind,:);
                
                depth=depth_surface(1,1:maxind); 
                bottomtot=depth_bottom(1,:,kfreq);
                tmp=find(bottomtot>max(depth)); if(~isempty(tmp)); bottomtot(tmp)=max(depth).*ones(length(tmp),1); end; clear tmp;
                bottom=bottomtot(tempek); 
                
                % calculation of mean acoustic profile
                Saprof=nanmean(Sa.'); Svprof=10.*log10(nanmean(10.^(Sv.'/10)));
                
                %==========================================================
                % FIGURE
                SupTitle='';%['PRESS "ESC" for zooms - PRESSE "Y" to return to the whole picture - COLOR SCALE: PRESS "A" or "Q" to increase or decrease the minimum color value (PRESS "Z" or "S" for increase or decrease its maximum value)' ];
                limax=[1 size(Svtot,2) min(depth) max(bottomtot)]; col=[-100 -40]; zoomcurrent=limax; ClimCurrent=col; DClim=10;
                tit={''};
                titcurrent=tit; Val=0; kcount=1; X=[]; Y=[]; aff=0;
                
               % while(Val==0)% | Val==3)
                    
                    close all; figure('units','normalized','outerposition',[0 0 1 1],'Name',SupTitle,'NumberTitle','off');
                    Y(1)=DepthDebutAllZone(IdP(1)+IndStation-1);              
                    Y(2)=DepthFinAllZone(IdP(1)+IndStation-1);
                    X(1)=IndStation;
                    X(2)=IndStation;
                    Val=1;
                    
                    FigManage;
                    
               % end  %while(Val==0 | Val==3)
                
                if(~isnan(Y(1)))
                    tmp=find(D>=Y(1) & D<=Y(2));
                    if(isempty(tmp))
                        Temp=NaN; Fluo=NaN; Oxy=NaN; Dens=NaN; Pc=0;
                    else
                        Temp=nanmean(prof(tmp,1)); Fluo=nanmean(prof(tmp,2)); Oxy=nanmean(prof(tmp,3)); Dens=nanmean(prof(tmp,4)); Pc=length(tmp)/length(D)*100;
                    end
                    clear tmp;
                    
                    tmp=find(depth>=Y(1) & depth<=Y(2)); Samoy=nanmean(Saprof(tmp)); tmp2=nanmean(10.^(Svprof(tmp)/10));
                    if(~isnan(tmp2) & tmp2>0)
                        Smoy=10.*log10(tmp2);
                    else
                        Smoy=NaN;
                    end
                    clear tmp tmp2;
                    
                    Station(Kstation,:)=[X(1),X(2),D(1),D(end),depth(1),bottomtot(IndStation),Time(X(1)),Y(1),bottomtot(X(1)),Time(X(2)),Y(2),bottomtot(X(2)),abs(Y(2)-Y(1)),Temp,Fluo,Oxy,Dens,Smoy,Samoy,Pc];
                else % si pas de couche
                    Temp=nanmean(prof(:,1)); Fluo=nanmean(prof(:,2)); Oxy=nanmean(prof(:,3)); Dens=nanmean(prof(:,4)); Smoy=10.*log10(nanmean(10.^(Svprof/10))); Samoy=nanmean(Saprof);
                    Station(Kstation,:)=[NaN,NaN,D(1),D(end),depth(1),bottomtot(IndStation),NaN,NaN,NaN,NaN,NaN,NaN,NaN,Temp,Fluo,Oxy,Dens,Smoy,Samoy,NaN];
                end
                SvMoyStation(Kstation).Sv=Svprof; SvMoyStation(Kstation).Sa=Saprof;
                
                %==========================================================
                % SAUVEGARDES
                
                ClimCurrent=col; zoomcurrent=limax; aff=1; FigManage; aff=0;
                if(SaveFIG==1)
                    str_st='000'; str_st(end-length(num2str(ind(kp)))+1:end)=num2str(ind(kp)); str_fr='000'; str_fr(end-length(num2str(transFreq(kfreq)/1000))+1:end)=num2str(transFreq(kfreq)/1000);
                    saveas(gcf,[pathSaveFig,repsave,'\',TrialName,'_Station',str_st,'-',str_fr,'kHz'],'fig');
                end
%                 if(SaveFIGppt==1)
%                     saveppt([pathSaveFig,repsave,'\',TrialName,'_AllStations.ppt']);
%                 end
                
                close all; pause(0.01); clear Sv depth bottom Svtot depth bottomtot;
                
            end %for kfreq=1:length(transFreq)
            clear Temperature Fluorescence Oxygene Density Smoy X Y Pc; clear tempek dtim tim proftot prof D Svprof Saprof pingdeb pingdebtot IndStation;
            
        end %for kp=1:length(ind)
        
    end % if(~isempty(ind))
    clear ind;
    IdP=IdP+NbEsuBloc;
    
end
for kfile=1:size(filemat,1)

if(~isempty(Station))
    LatitudeStation=lat; LongitudeStation=lon;
    save([pathSaveFig,repsave,'\Stations_',TrialName,'_',str_fr0,'kHz.mat'],'JourNuitStation','DateESU','LatitudeStation','LongitudeStation','Station','SvMoyStation');
    
    % writing the excel file of results
    fid=fopen([pathSaveFig,repsave,'\Stations_',TrialName,'_',str_fr0,'kHz.xls'],'wt');
    fprintf(fid,'Nstation \t Date station \t Latitude station (deg) \t Longitude station (deg) \t Ephemeride at the station (m) \t max depth station (m) \t Minimum depth echogram on station (m) \t Maximum depth echogram on station (m) \t Date point1 (seconde 1970) \t depth point1 (m) \t bottom point1 (m) \t Date point2 (seconde 1970) \t depth point2 (m) \t bottom au point2 (m) \t thickness layer (m) \t mean temperature in the layer (C) \t mean Fluorescence (g/l) \t mean oxygen (mol/kg) \t mean density (kg/m3) \t mean Sv  (dB) \t mean Sa  (NASC) \t Percentage of recovery of station profiles by layer\n');
    for k=1:size(Station,1)
        fprintf(fid,'%i \t %s \t %4.4f \t %4.4f \t %s \t %4.2f \t %4.2f \t %4.2f \t %4.2f \t %4.4f \t %4.2f \t %4.2f \t %4.4f \t %4.2f \t %4.2f \t %4.2f \t %4.2f \t %4.2f \t %4.2f \t %4.2f \t %4.2f \t %4.2f \t %4.2f \n',k,char(timpstr(k,:)),lat(k),lon(k),char(JourNuitStation(k,:)),Station(k,3:end));
    end
    fclose all;
    fprintf('\n'); fprintf('The results are saved in the directory:\n'); fprintf('%s\n',[pathSaveFig,repsave]);
    cd([pathSaveFig,repsave]);
else
    fprintf('No stations were treated !!!\n');
end
end

warning('on')




%%%




