clear all; %close all;
% directory address containing the files Echointegration.mat and Layer.mat
adress_acou='C:\Users\USER\Desktop\NEW_ARTICLE\CEprofil\ECOAO2013\Cruise_ECOAO2013\Treatment20171026_221343_75DB\CleanResults\Echointegration\';
% directory address where to save the results
adress_save='C:\Users\USER\Desktop\NEW_ARTICLE\CEprofil\\Echointegration\ComparEchoProfil_couche\RESULTATS\';

% Frequency index that are ranked in ascending order of frequency
kfreq=1;  

%**************************************************************************

load([adress_acou,'Echointegration.mat'],'Time','Sv_surface','Sa_surface','depth_surface','depth_bottom','TransducerDepth','Night1Sunrise2Day3Sunset4','FrequencySort','BottomShift');
load([adress_acou,'Layer.mat'],'CleanLayMask','LayDescription38','LayDescriptionHeader');
LayDescription=LayDescription38;

nbcouche=size(LayDescription,1);  % LayDescription38 --> nb couche * nbre descripteur
nbesu=size(Time,2);
%nbesu=LayDescription(:,7);
IdCouche=LayDescription(:,1);
IdStartCouche=LayDescription(:,5); IdEndCouche=LayDescription(:,6);
TimeStartCouche=LayDescription(:,9); TimeEndCouche=LayDescription(:,10);
DepStartCouche=LayDescription(:,11); DepEndCouche=LayDescription(:,12);
Zone=LayDescription(:,2);
EpCouche=DepEndCouche-DepStartCouche;
d=depth_surface;
nbzone=max(Zone);
EpAllZone=zeros(1,nbesu); SvAllZone=NaN(1,nbesu); SaAllZone=NaN(1,nbesu); IndiceCoucheAllZone=NaN(1,nbesu);
DepthDebutAllZone=NaN(1,nbesu); DepthFinAllZone=NaN(1,nbesu); IdDepthDebutAllZone=NaN(1,nbesu); IdDepthFinAllZone=NaN(1,nbesu);
for izone=1:nbzone
    tmp0=find(Zone==izone); 
    if(~isempty(tmp0))
        
        tmp0=tmp0(1); ZoneId=[IdStartCouche(tmp0):IdEndCouche(tmp0)]; 
        
        layer=CleanLayMask(:,ZoneId,kfreq); Sv0=Sv_surface(:,ZoneId,kfreq); Sa0=Sa_surface(:,ZoneId,kfreq); Id0=NaN(1,length(ZoneId));
        
        Ep=zeros(1,length(ZoneId)); Sv=NaN(1,length(ZoneId)); Sa=NaN(1,length(ZoneId));
        DepthDebut=NaN(1,length(ZoneId)); DepthFin=NaN(1,length(ZoneId)); IdDepthDebut=NaN(1,length(ZoneId)); IdDepthFin=NaN(1,length(ZoneId));
        for k=1:length(ZoneId)
            tmp=find(layer(:,k)~=0);
            if(~isempty(tmp))
                IdDebut=min(tmp); IdFin=max(tmp); Id0(k)=layer(IdDebut,k);
                if(layer(IdDebut,k)==layer(IdFin,k))
                    Sv(1,k)=10.*log10(nanmean(10.^(Sv0(IdDebut:IdFin,k)./10)));
                    Sa(1,k)=nanmean(Sa0(IdDebut:IdFin,k));
                    Ep(1,k)=d(IdFin)-d(IdDebut);
                    DepthDebut(1,k)=d(IdDebut); DepthFin(1,k)=d(IdFin); IdDepthDebut(1,k)=IdDebut; IdDepthFin(1,k)=IdFin;
                    if(Sv(1,k)==0)
                        Sv(1,k)=NaN; Sa(1,k)=NaN;
                    end
                else
                    tmp2=find(layer(:,k)~=layer(IdDebut,k)); layer2=layer(:,k); layer2(tmp2)=0; clear tmp2;
                    clear tmp; tmp=find(layer2~=0);
                    if(~isempty(tmp))
                        Sv(1,k)=10.*log10(nanmean(10.^(Sv0(IdDebut:IdFin,k)./10)));
                        Sa(1,k)=nanmean(Sa0(IdDebut:IdFin,k));
                        Ep(1,k)=d(max(tmp))-d(min(tmp));
                        DepthDebut(1,k)=d(IdDebut); DepthFin(1,k)=d(IdFin); IdDepthDebut(1,k)=IdDebut; IdDepthFin(1,k)=IdFin;
                        if(Sv(1,k)==0)
                            Sv(1,k)=NaN; Sa(1,k)=NaN;
                        end
                    end
                    clear layer2;
                end
            end
            clear tmp;
        end
        IndiceCoucheAllZone(1,ZoneId(1):ZoneId(end))=Id0;
        EpAllZone(1,ZoneId(1):ZoneId(end))=Ep;
        SvAllZone(1,ZoneId(1):ZoneId(end))=Sv;
        SaAllZone(1,ZoneId(1):ZoneId(end))=Sa;
        DepthDebutAllZone(1,ZoneId(1):ZoneId(end))=DepthDebut; 
        DepthFinAllZone(1,ZoneId(1):ZoneId(end))=DepthFin; 
        IdDepthDebutAllZone(1,ZoneId(1):ZoneId(end))=IdDepthDebut; 
        IdDepthFinAllZone(1,ZoneId(1):ZoneId(end))=IdDepthFin;
        
        clear ZoneId layer Ep Sv Sa Id0 DepthDebut DepthFin IdDepthDebut IdDepthFin;        
    end
    clear tmp0;
end
save([adress_save,'EpSvSa.mat'],'IndiceCoucheAllZone','EpAllZone','SvAllZone','SaAllZone','DepthDebutAllZone','DepthFinAllZone','IdDepthDebutAllZone','IdDepthFinAllZone')
